/*
Keyless Entry Slave
I2C libary: http://playground.arduino.cc/Code/USIi2c
Ansteuerung der H-Bruecke
Getestet mit:
	Visual-Studio 2015 Community
	Plugin Visual-Micro  & Arduino 1.0.5-r2

*/



#include "TinyWireS.h"
#include <avr/io.h>
#include <interrupt.h>
#include <stdlib.h>

#define I2C_SLAVE_ADDR 0x08

#define F_CPU 8000000UL



void setup() {


	DDRB |= 0b00001010;							// OUTPUT  {B3 B1}


	TinyWireS.begin(I2C_SLAVE_ADDR);              // initialize I2C lib & setup slave's address (7 bit - same as Wire)

	sei();              // global interrupt enable
	
}





void Vorwaerts()
{
	PORTB &= 0b11111101; //B1 Aus
	PORTB |= 0b00001000; //B3 An
}

void Aus()
{
	PORTB &= 0b11110101; // {B1 ,B3}Aus
}

void Rueckwaerts()
{
	PORTB &= 0b11110111; //B3 Aus
	PORTB |= 0b00000010; //B1 An
}



void loop() {


	while (TinyWireS.available())
	{
		char input = (char)TinyWireS.receive();

		if (input == '1')
		{
			
			Rueckwaerts();
			int sensorValue_old = 0;
			for (int i = 0; i < 2000; i++)
			{

				if (i > 100)   //erste 0.1 Sekunden keine Stromabschaltung (wegen Einschaltstrom)
				{
					int sensorValue = (analogRead(A2) + sensorValue_old) / 2; // Ein bisschen Filtern

					if (sensorValue > 16)break;  //Blockierstrom ~800mA , Messwiderstand = 0.1 Ohm
											     //Spannung bei Blockieren = 80mV
												 //ADC-Wert von 16 ==> 78mV
					sensorValue_old = sensorValue;
				}
				delay(1);
			}
			Aus();
			
			
		}

		if (input == '2')
		{

			Vorwaerts();
			int sensorValue_old = 0;
			
			for (int i = 0; i < 2000;i++)
			{
				
				if (i > 100)   //erste 0.1 Sekunden keine Stromabschaltung (wegen Einschaltstrom)
				{
					int sensorValue = (analogRead(A2)+sensorValue_old )/2; // Ein bisschen Filtern

					if (sensorValue > 16)break;
					sensorValue_old = sensorValue;
				}
				delay(1);
			}
			Aus();
			
		}

	}
	

}
	


	
		

